#ifndef __ami_h
#define __ami_h

class AMI
{
    public:
	static AMI *list;
	AMI *next;

	string host;
	int port;
	string username;
	string secret;
	string name;

	string initString;

	int control;
	short authenticated;

	time_t errState;
	time_t retryPeriod;

	struct cb_list_type
	{
	    string eventID;
	    AMI_CALLBACK func;
	    string actionID;
	    struct cb_list_type *next;
	} *cb_list;

	static struct cb_list_type event_callback_list[];

	static int init();
	static void loopAll();
	static void Shutdown();
	bool Loop();

	bool Connected() { return control?true:false; }
	bool Connect();
	void Disconnect();
	bool Authenticated() { return authenticated?true:false; }
	bool Authenticate();

	void HandleMSG(MSG *);

	MSG *m;


	AMI(const char *name, const char *host, int port, const char *username, const char *secret, time_t _retry);
	~AMI();

	bool operator<<(string &);
	bool operator<<(const char *);

	void RegisterActionCB(string &actionID, AMI_CALLBACK cb);
	void RegisterEventCB(string &eventID, AMI_CALLBACK cb);

	void RegisterAllEvents();

	void Authenticate_Reply(MSG *);
	void HandleViaLog(MSG *);

	void __Dial(MSG*);
	void __Newchannel(MSG*);
	void __NewCallerid(MSG*);
	void __Newstate(MSG*);
	void __Bridge(MSG*);
	void __Unlink(MSG*);
	void __Hangup(MSG*);
};


#endif  // #ifndef __ami_h
