#ifndef __channel_h
#define __channel_h

class CHANNEL; class DEVICE;

class DEVICE
{
    public:
	string name;

	string type; string ext;
	unsigned openChannels;

	CHANNEL *chan_list;
	static DEVICE *dev_list;

	DEVICE *dev_next;

	static DEVICE *Find(string _name, bool ifExists = false)
	{
	    for (DEVICE *d = dev_list; d; d = d->dev_next)
		if (d->name == _name) return d;

	    if (ifExists) return NULL;

	    return new DEVICE(_name);
	}

	DEVICE(string _name)
	{
	    dev_next = dev_list;
	    dev_list = this;
	    name = _name;
	    chan_list = NULL;
	    openChannels = 0;

	    size_t x = name.find("/");
	    if (x != string::npos)
	    {
		type = name.substr(0,x);
		ext = name.substr(x+1);
	    }
	    else
	    {
		type = "UNKNOWN";
		ext = name;
	    }
	}

	~DEVICE();

	void RegChannel(CHANNEL *chan);
	void UnregChannel(CHANNEL *chan);
};



class CHANNEL
{
    public:
	static CHANNEL *chan_list;
	CHANNEL *chan_next;

	CHANNEL *chan_next_same_dev;

	CHANNEL *Bridge;

	static CHANNEL *Find(string _name, bool ifExists=false)
	{
	    size_t x = _name.find(";");
	    if (x != string::npos)
		_name = _name.substr(0,x);

	    for (CHANNEL *ch = chan_list; ch; ch = ch->chan_next)
		if (ch->name == _name) return ch;

	    if (ifExists) return NULL;

	    return new CHANNEL(_name);
	}

	CHANNEL(string _name)
	{
	    name = _name;
	    size_t x = name.find("-");
	    if (x!=string::npos)
		(dev=DEVICE::Find(name.substr(0,x)))->RegChannel(this);
	    else dev = NULL;

	    Bridge = NULL;

	    chan_next = chan_list;
	    chan_list = this;
	}
	~CHANNEL()
	{
	    if (dev) dev->UnregChannel(this);

	    if (Bridge)
	    {
		Bridge->Bridge=NULL;
		Bridge=NULL;
	    }

	    CHANNEL *ch=chan_list;
	    if (ch == this) chan_list = chan_next;
	    else
	    {
		while (ch && ch->chan_next && ch->chan_next != this)
		     ch = ch->chan_next;
		if (ch->chan_next) ch->chan_next = chan_next;
	    }
	}

	string name;
	DEVICE *dev;

	int state;
	string context;
	string CIDNum;
	string CIDName;
};


#endif
