#ifndef __msg_h
#define __msg_h
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
extern char line_buf[];
class MSGAttribute
{

    public:
	string attr;
	string value;
	MSGAttribute *next;

	MSGAttribute(string _attr)
	{
	    attr = _attr;
	    value = "";
	    next = NULL;
	}

	operator const char *()
	{
	    return value.c_str();
	}

	operator string()
	{
	    return value;
	}

	~MSGAttribute()
	{
	    if (next) delete next;
	}


	string operator<<(string _val)
	{
	    value = _val;
	    return value;
	}

	string operator<<(long _val)
	{
	    value = toStr(_val);
	    return value;
	}

	string operator<<(const char *_val)
	{
	    value = _val;
	    return value;
	}
};

class MSG
{
    public:

	static MSG *list;
	MSG *next;

	iostream *in;
	class AMI *ami;
	bool initializedAMI;

	bool complete;
	string unfinishedLine;

	MSGAttribute *attr_list_in;
	MSGAttribute *attr_list_out;

	MSG(iostream &);
	MSG(AMI *);
	~MSG();

	static MSG *Read(iostream &);
	static MSG *Tie(iostream &);

	static MSG *Tie(AMI *);
	static MSG *Read(AMI *);
	MSG *Read();
	MSG *ReadAMI();

	MSGAttribute &retr(MSGAttribute *&, string &);

	MSGAttribute &Attr(string &left) {return retr(attr_list_in, left);}
	MSGAttribute &Attr(const char *left){string _left = left; return retr(attr_list_in, _left); }

	MSGAttribute &Pack(string &left) {return retr(attr_list_out, left);}
	MSGAttribute &Pack(const char *left){string _left = left; return retr(attr_list_out, _left); }

	operator string()
	{
	    stringstream s;

	    for (MSGAttribute *a = attr_list_out; a; a = a->next)
		s << a->attr << ": "<<*a<<"\r\n";

	    s << "\r\n";

	    clear();

	    return s.str();
	}


	void clear() { if (attr_list_out) delete attr_list_out; attr_list_out = NULL; }
	bool SendPack(AMI_CALLBACK cb=NULL);
};




#endif // #ifndef __msg_h
